%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
%   Il programma diagramma una funzione di probabilit di una variabile   %  
%     aleatoria Gaussiana di dimensione due, fissati il vettore delle     %
%                  medie e la matrice di covarianza.                      %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
clc;
clear

% Inserire il vettore delle medie (mvett)
mvett=input('Inserire il vettore (riga) delle medie:  ');
% Inserire la matrice di covarianza (V)
V = input('Inserire la matrice di covarianza:  ');

% Calcolo del vettore x ed y contenenti i punti in cui valutare la f. Tali
% vettori vengono costruiti come:
% x = [mu(x) - 3*V(x,x), mu(x) + 3*V(x,x)]
% y = [mu(y) - 3*V(y,y), mu(y) + 3*V(y,y)]
Xvett = [mvett(1)-3*V(1,1):0.1:mvett(1)+3*V(1,1)];
Yvett = [mvett(2)-3*V(2,2):0.1:mvett(2)+3*V(2,2)];

% Generazione della mesh per il diagramma 3D. Si usa il comando "meshgrid".
% La funzione f(x,y) sar calcolata nei punti della matrice generata da
% "meshgrid" (in questo caso la matrice [X,Y]).
[X,Y] = meshgrid(Xvett,Yvett);

% Calcolo del vettore (x-mu)
x = X - mvett(1);
y = Y - mvett(2);

% Calcolo della costante al denominatore della PDF
costantef = (1/(2*pi*sqrt(det(V))));

% Calcolo dell'inversa di V
inversaV = inv(V);

% Calcolo del numeratore dell'esponenziale della PDF. Si noti che in questa
% formula x ed y sono le componenti del vettore (x-mu). Inoltre si noti che
% il numeratore  stato sviluppato come somma di 4 termini.
numExp = x.^2*inversaV(1,1)+(x.*y)*inversaV(1,2)+(x.*y)*inversaV(2,1)+y.^2*inversaV(2,2);

% Calcolo della PDF
f = costantef*exp((-numExp)/2);

% Diagramma della PDF. Si  utilizzata la funzione "surf" che genera un
% diagramma di superficie
figure(1)
surf(X,Y,f)

% Diagramma della PDF. Si  utilizzata la funzione "contour" che genera le
% curve di isolivello della funzione. In questo caso sono riportate 20
% curve di isolivello.
figure(2)
contour(X,Y,f,20)

% Genera delle griglie nelle figure precedenti
grid on